<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
	<div class="glossary-tab-content">
		<div class="catalog-page">
			<Datatable :data="data" @open-edit-modal="handleOpenEditModal">
				<button class="button-stroke-transparent" @click="showCreateTermModal = true">Add
					Term</button>
				<div class="filters-top-totals"><b>{{ props?.terms?.length }} Term(s)</b> available
				</div>
			</Datatable>
		</div>
	</div>
	<ClientOnly>
		<Teleport to="#modals-container">
			<ModalsCreateTerm v-if="showCreateTermModal" @toggle="close" :isEditMode="isEditMode" :glossaryId="route.params.id.toString()" :row="selectedRow ? selectedRow : ''"  @refresh-data="handleRefreshData"/>
		</Teleport>
	</ClientOnly>
</template>

<script setup lang="ts">
import type DataTableI from '~/interfaces/datatable';

const props = defineProps({
	tabs: {
		type: Object,
		default: () => ({ tabs: [] })
	},
	terms: {
		type: Object,
		default: () => ({ terms: [] })
	}
}); 

interface GlossaryTerms {
    id: number;
    name: string;
    type: string;
    group: string;
    domains: any;
    description: string;
	summary: string;
    updatedAt: string;
    createdAt: string;
}

const populateRows = () => {
    
    // Use .map to create the initial rows array
    const rows = props?.terms?.map((glossaryTerm: GlossaryTerms) => ({
        id: glossaryTerm.id,
        name: glossaryTerm.name,
        type: 'Term',
        group: '',
        domains: '',
        description: '',
        summary: '',
        edited_at: '',
        created_at: '',
        actions: ''
    }));

    // Promise.all for the detailed rows fetch operation
    const detailedRowsPromises = props?.terms?.map((glossaryTerm: GlossaryTerms) => {
        return useFetchAuth(`/terms/${glossaryTerm.id}`)
            .then((details) => {
                const glossaryDetails = details as GlossaryTerms;
                return {
                    id: glossaryTerm.id,
                    name: glossaryTerm.name,
                    type: 'Term',
                    group: '',
                    description: glossaryDetails?.description,
                    summary: glossaryDetails?.summary,
                    edited_at: formatDate(glossaryDetails?.updatedAt),
                    created_at: formatDate(glossaryDetails?.createdAt),
                    actions: ''
                };
            })
            .catch((error) => {
                console.error(`Failed to fetch details for dataset ${glossaryTerm.id}:`, error);
                return {
                    id: glossaryTerm.id,
                    name: glossaryTerm.name,
                    type: 'Term',
                    group: '',
                    domains: '',
                    description: '',
                    summary: '',
                    edited_at: '',
                    created_at: '',
                    actions: ''
                };
            });
    });

    // Use Promise.all to wait for all the fetch requests to finish
    Promise.all(detailedRowsPromises)
        .then((detailedRows) => {
            console.log('Fetched detailed rows:', detailedRows);
            data.value.rows = detailedRows;  // Update rows with the fetched data
            console.log('Rows updated:', data.value.rows);
        })
        .catch((error) => {
            console.error('Error in fetching rows:', error);
        });
};

const handleRefreshData = () => {
	populateRows();
};

onMounted(() => {
  populateRows();
});

watch(() => props.terms, () => {
  populateRows();
}, { deep: true });

const route = useRoute();

const data = ref<DataTableI>({
	options: {
		tableName: 'glossary-table',
		detailsPath: '/glossary/terms/', 
		allowCheckRow: true,
		favourites: true,
		previewComponent: 'TermsDetails', 
	},
	columns: [
		{
			id: 1,
			name: 'name',
			label: 'Name',
			combineColumn: 'type',
			renderComponent: 'TableColumnsName',
			// width: '200px'
		},
		{
			id: 4,
			name: 'summary',
			label: 'Description',
			width: '60%'
		},
		{
            id: 6,
            name: 'actions',
            label: 'Actions',
            width: '80px',
            hideLabel: true
        }
	],
	rows: []
});

const showCreateTermModal = ref(false);
const showCreateGlossaryModal = ref(false);
const showDeleteModal = ref(false);
const selectedRow = ref(null);
const isEditMode = ref(false); 

const handleOpenEditModal = (row: any) => {
    selectedRow.value = row?.id; // Pass the selected row data to the modal
    isEditMode.value = true;
    showCreateTermModal.value = true; // Open the Edit Dataset modal
};

const close = () => {
	if(showCreateTermModal){
		showCreateTermModal.value = false;
	}
	if(showCreateGlossaryModal){
		showCreateGlossaryModal.value = false;
		isEditMode.value = false;
	}
};

</script>